(function() {
  var LinodeClient, api_defs, errors, fs, qs, request;
  request = require('request');
  qs = require('querystring');
  fs = require('fs');
  api_defs = JSON.parse(fs.readFileSync(__dirname + '/../data/api.json'));
  errors = {
    0: 'ok',
    1: 'Bad request',
    2: 'No action was requested',
    3: 'The requested class does not exist',
    4: 'Authentication failed',
    5: 'Object not found',
    6: 'A required property is missing for this action',
    7: 'Property is invalid',
    8: 'A data validation error has occurred',
    9: 'Method Not Implemented',
    10: 'Too many batched requests',
    11: 'RequestArray isn\'t valid JSON or WDDX',
    12: 'Batch approaching timeout. Stopping here.',
    13: 'Permission denied',
    30: 'Charging the credit card failed',
    31: 'Credit card is expired',
    40: 'Limit of Linodes added per hour reached',
    41: 'Linode must have no disks before delete'
  };
  LinodeClient = (function() {
    function LinodeClient(api_key) {
      this.api_key = api_key;
      this.base_uri = "https://api.linode.com/?api_key=" + this.api_key;
    }
    LinodeClient.prototype.call = function(action, args, callback) {
      var uri;
      uri = "" + this.base_uri + "&api_action=" + action + "&" + (qs.stringify(args));
      return request({
        uri: uri
      }, function(err, res, body) {
        var obj;
        obj = JSON.parse(body);
        if (obj.ERRORARRAY.length > 0) {
          return callback(errors[obj.ERRORARRAY[0]], void 0);
        } else {
          return callback(void 0, obj.DATA);
        }
      });
    };
    return LinodeClient;
  })();
  exports.LinodeClient = LinodeClient;
}).call(this);
